//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4AB7B8DF0166.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4AB7B8DF0166.cm

//## begin module%4AB7B8DF0166.cp preserve=no
//## end module%4AB7B8DF0166.cp

//## Module: PlotGroupCreator%4AB7B8DF0166; Package specification
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotGroupCreator.h

#ifndef PLOTGROUPCREATOR_H
#define PLOTGROUPCREATOR_H 1

//## begin module%4AB7B8DF0166.additionalIncludes preserve=no
//## end module%4AB7B8DF0166.additionalIncludes

//## begin module%4AB7B8DF0166.includes preserve=yes
#include <xsTypes.h>
#include <vector>
//## end module%4AB7B8DF0166.includes


struct PlotGroup;
class PlotSettings;

//## begin module%4AB7B8DF0166.declarations preserve=no
//## end module%4AB7B8DF0166.declarations

//## begin module%4AB7B8DF0166.additionalDeclarations preserve=yes
//## end module%4AB7B8DF0166.additionalDeclarations


//## begin PlotGroupCreator%4AB7C14001A9.preface preserve=yes
//## end PlotGroupCreator%4AB7C14001A9.preface

//## Class: PlotGroupCreator%4AB7C14001A9
//	Abstract strategy class for acquiring data from various
//	parts of Xspec and bundling into PlotGroups
//## Category: XSPlot::Plot%3D625E6A0065
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%4AB7C76E0076;PlotGroup { -> F}
//## Uses: <unnamed>%4AC385350029;PlotSettings { -> F}

class PlotGroupCreator 
{
  //## begin PlotGroupCreator%4AB7C14001A9.initialDeclarations preserve=yes
  //## end PlotGroupCreator%4AB7C14001A9.initialDeclarations

  public:
    //## Destructor (generated)
      virtual ~PlotGroupCreator();


    //## Other Operations (specified)
      //## Operation: createPlotGroups%4AB7C540034D
      virtual std::vector<PlotGroup*> createPlotGroups (const PlotSettings& settings) = 0;

      //## Operation: determineXRange%4B3D0F7A0010
      static void determineXRange (const std::vector<PlotGroup*>& plotGroups, Real* pXlow, Real* pXhigh);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: NODATA%4AC2658402EE
      static Real NODATA ();

    // Additional Public Declarations
      //## begin PlotGroupCreator%4AB7C14001A9.public preserve=yes
      //## end PlotGroupCreator%4AB7C14001A9.public

  protected:
    //## Constructors (generated)
      PlotGroupCreator();


    //## Other Operations (specified)
      //## Operation: setXaxis%4AC259F2015A
      static void setXaxis (const PlotSettings& settings, PlotGroup* group, int firstChannel, int lastChannel, Real eMin, Real eMax, int point);

    // Additional Protected Declarations
      //## begin PlotGroupCreator%4AB7C14001A9.protected preserve=yes
      //## end PlotGroupCreator%4AB7C14001A9.protected

  private:
    //## Constructors (generated)
      PlotGroupCreator(const PlotGroupCreator &right);

    //## Assignment Operation (generated)
      PlotGroupCreator & operator=(const PlotGroupCreator &right);

    // Additional Private Declarations
      //## begin PlotGroupCreator%4AB7C14001A9.private preserve=yes
      //## end PlotGroupCreator%4AB7C14001A9.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin PlotGroupCreator::NODATA%4AC2658402EE.attr preserve=no  public: static Real {UC} -1.2e-34
      static const Real s_NODATA;
      //## end PlotGroupCreator::NODATA%4AC2658402EE.attr

    // Additional Implementation Declarations
      //## begin PlotGroupCreator%4AB7C14001A9.implementation preserve=yes
      //## end PlotGroupCreator%4AB7C14001A9.implementation

};

//## begin PlotGroupCreator%4AB7C14001A9.postscript preserve=yes
//## end PlotGroupCreator%4AB7C14001A9.postscript

// Class PlotGroupCreator 

//## Get and Set Operations for Class Attributes (inline)

inline Real PlotGroupCreator::NODATA ()
{
  //## begin PlotGroupCreator::NODATA%4AC2658402EE.get preserve=no
  return s_NODATA;
  //## end PlotGroupCreator::NODATA%4AC2658402EE.get
}

//## begin module%4AB7B8DF0166.epilog preserve=yes
//## end module%4AB7B8DF0166.epilog


#endif
